apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ mastodon_name }}
  name: {{ mastodon_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ mastodon_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ mastodon_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ mastodon_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    recreateParams:
      timeoutSeconds: 1800
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ mastodon_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ mastodon_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ mastodon_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ mastodon_name }}
        - name: ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ mastodon_name }}
        - name: AWS_ACCESS_KEY_ID
{% if do_s3 %}
{% if mastodon_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name | default('s3') }}-mastodon
        - name: AWS_SECRET_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name | default('s3') }}-mastodon
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name | default('s3') }}-mastodon
        - name: AWS_SECRET_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name | default('s3') }}-mastodon
{% else %}
          value: ""
        - name: AWS_SECRET_ACCESS_KEY
          value: ""
{% endif %}
{% else %}
          value: ""
        - name: AWS_SECRET_ACCESS_KEY
          value: ""
{% endif %}
        - name: COMPONENT
          value: web
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtpg_name }}
        - name: DB_HOST
          value: {{ mtpg_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtpg_name }}
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtpg_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: LOCAL_DOMAIN
          value: {{ mastodon_fqdn }}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=mastodon,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: mastodon-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: OTP_SECRET
          valueFrom:
            secretKeyRef:
              key: otp-secret
              name: {{ mastodon_name }}
        - name: REDIS_HOST
          value: {{ cache_name }}
        - name: S3_BUCKET
{% if do_s3 %}
{% if mastodon_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name | default('s3') }}-mastodon
        - name: S3_HOST
          value: {{ minio_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ minio_api_address | urlsplit('port') }}"
        - name: S3_PROTOCOL
          value: "{{ minio_api_address | urlsplit('scheme') }}"
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name | default('s3') }}-mastodon
        - name: S3_SIGNATURE_VERSION
          value: v2
        - name: S3_OVERRIDE_PATH_STYLE
          value: "true"
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name | default('s3') }}-mastodon
        - name: S3_HOST
          value: {{ radosgw_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ radosgw_api_address | urlsplit('port') }}"
        - name: S3_PROTOCOL
          value: "{{ radosgw_api_address | urlsplit('scheme') }}"
        - name: S3_SIGNATURE_VERSION
          value: v2
        - name: S3_OVERRIDE_PATH_STYLE
          value: "true"
{% else %}
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_PROTOCOL
          value: ""
        - name: S3_SIGNATURE_VERSION
          value: ""
        - name: S3_OVERRIDE_PATH_STYLE
          value: ""
{% endif %}
{% else %}
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_PROTOCOL
          value: ""
        - name: S3_SIGNATURE_VERSION
          value: ""
        - name: S3_OVERRIDE_PATH_STYLE
          value: ""
{% endif %}
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key-base
              name: {{ mastodon_name }}
        - name: SMTP_FROM_ADDRESS
          value: noreply@{{ root_domain }}
        - name: SMTP_SERVER
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: peer
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: VAPID_PRIVATE_KEY
          valueFrom:
            secretKeyRef:
              key: vapid-private
              name: {{ mastodon_name }}
        - name: VAPID_PUBLIC_KEY
          valueFrom:
            secretKeyRef:
              key: vapid-public
              name: {{ mastodon_name }}
{% if do_triggers == False or (opsimages | json_query("[?name=='mastodon'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='mastodon'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 58
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 3000
          timeoutSeconds: 5
        name: web
        ports:
        - containerPort: 3000
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ mastodon_fqdn }}
            - name: X-Forwarded-Proto
              value: https
            path: /about
            port: 3000
          initialDelaySeconds: 60
          periodSeconds: 20
          timeoutSeconds: 10
        resources:
          limits:
            cpu: "{{ mastodon_web_cpu_limit }}"
            memory: "{{ mastodon_web_memory_limit }}"
          requests:
            cpu: "{{ mastodon_web_cpu_request }}"
            memory: "{{ mastodon_web_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 58
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 3000
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
{% endif %}
        - mountPath: /opt/app-root/lib/pm2/.config
          name: tmp
        - mountPath: /opt/mastodon/public/system/accounts
          name: data
      - env:
        - name: AWS_ACCESS_KEY_ID
{% if do_s3 %}
{% if mastodon_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name | default('s3') }}-mastodon
        - name: AWS_SECRET_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name | default('s3') }}-mastodon
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name | default('s3') }}-mastodon
        - name: AWS_SECRET_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name | default('s3') }}-mastodon
{% else %}
          value: ""
        - name: AWS_SECRET_ACCESS_KEY
          value: ""
{% endif %}
{% else %}
          value: ""
        - name: AWS_SECRET_ACCESS_KEY
          value: ""
{% endif %}
        - name: COMPONENT
          value: streaming
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtpg_name }}
        - name: DB_HOST
          value: {{ mtpg_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtpg_name }}
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtpg_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: LOCAL_DOMAIN
          value: {{ mastodon_fqdn }}
        - name: OTP_SECRET
          valueFrom:
            secretKeyRef:
              key: otp-secret
              name: {{ mastodon_name }}
        - name: REDIS_HOST
          value: {{ cache_name }}
        - name: S3_BUCKET
{% if do_s3 %}
{% if mastodon_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name | default('s3') }}-mastodon
        - name: S3_HOST
          value: {{ minio_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ minio_api_address | urlsplit('port') }}"
        - name: S3_PROTOCOL
          value: "{{ minio_api_address | urlsplit('scheme') }}"
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name | default('s3') }}-mastodon
        - name: S3_SIGNATURE_VERSION
          value: v2
        - name: S3_OVERRIDE_PATH_STYLE
          value: "true"
{% elif mastodon_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name | default('s3') }}-mastodon
        - name: S3_HOST
          value: {{ radosgw_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ radosgw_api_address | urlsplit('port') }}"
        - name: S3_PROTOCOL
          value: "{{ radosgw_api_address | urlsplit('scheme') }}"
        - name: S3_SIGNATURE_VERSION
          value: v2
        - name: S3_OVERRIDE_PATH_STYLE
          value: "true"
{% else %}
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_PROTOCOL
          value: ""
        - name: S3_SIGNATURE_VERSION
          value: ""
        - name: S3_OVERRIDE_PATH_STYLE
          value: ""
{% endif %}
{% else %}
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_PROTOCOL
          value: ""
        - name: S3_SIGNATURE_VERSION
          value: ""
        - name: S3_OVERRIDE_PATH_STYLE
          value: ""
{% endif %}
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key-base
              name: {{ mastodon_name }}
        - name: SMTP_FROM_ADDRESS
          value: noreply@{{ root_domain }}
        - name: SMTP_SERVER
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: peer
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: VAPID_PRIVATE_KEY
          valueFrom:
            secretKeyRef:
              key: vapid-private
              name: {{ mastodon_name }}
        - name: VAPID_PUBLIC_KEY
          valueFrom:
            secretKeyRef:
              key: vapid-public
              name: {{ mastodon_name }}
{% if do_triggers == False or (opsimages | json_query("[?name=='mastodon'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='mastodon'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 58
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 4000
          timeoutSeconds: 5
        name: streaming
        ports:
        - containerPort: 4000
        readinessProbe:
          httpGet:
            path: /api/v1/streaming/health
            port: 4000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ mastodon_streaming_cpu_limit }}"
            memory: "{{ mastodon_streaming_memory_limit }}"
          requests:
            cpu: "{{ mastodon_streaming_cpu_request }}"
            memory: "{{ mastodon_streaming_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 58
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 4000
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
{% endif %}
        - mountPath: /opt/mastodon/public/system/accounts
          name: data
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ mastodon_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_s3 %}
      - emptyDir: {}
        name: data
{% else %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ mastodon_name }}
{% endif %}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_lemon or do_ldap %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='mastodon'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - web
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='mastodon'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - streaming
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='mastodon'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
